PAD_A = $01
PAD_B = $02
PAD_SELECT = $04
PAD_START = $08
PAD_UP = $10
PAD_DOWN = $20
PAD_LEFT = $40
PAD_RIGHT = $80
.global NMI_CALL, reset, CTRL_PORT1, PAD_BUF, PAD_STATE, PAD_STATEP, PAD_STATET


padInit:  
 lda #0
 sta <PAD_STATE
 sta <PAD_STATEP
 sta <PAD_STATET
 rts 

padPoll:  
 ldx #0
 jsr padPollPort
 jsr padPollPort
 jsr padPollPort

 lda <PAD_BUF
 cmp <PAD_BUF+1
 beq @done
 cmp <PAD_BUF+2
 beq @done
 lda <PAD_BUF+1
@done:  
 sta <PAD_STATE

 lda <PAD_STATE
 eor <PAD_STATEP
 and <PAD_STATE
 sta <PAD_STATET
 lda <PAD_STATE
 sta <PAD_STATEP

 rts 

padPollPort:  
 ldy #$01
 sty CTRL_PORT1
 dey 
 sty CTRL_PORT1
 ldy #8
@1:  
 lda CTRL_PORT1
 and #$01
 clc 
 beq @2
 sec 
@2:  
 ror <PAD_BUF,x
 dey 
 bne @1

 inx 
 rts 
